#pragma once

#include <string>
#include <functional>

namespace qthing {

    namespace measured {

        typedef std::function<float()> sensor_t;
        typedef std::function<void(std::string name, std::string type, std::string unit, float value)> backend_t;

        void registerBackend(backend_t new_backend);
        void registerSensor(std::string name, std::string type, std::string unit, sensor_t sensor);

        namespace backend {
            void mqtt(std::string name, std::string type, std::string unit, float value);
        }
    }
}